
SinOsc s;

s.freq(440.);
s.gain(0.2);
SinOsc freqmod => blackhole;
freqmod.freq(0.1);

//use three buffers
LiSa l[3];
.9::second => dur bufferlen;
0 => int recbuf;
2 => int playbuf;

//LiSa params
for(0=>int i; i<3; i++) {
    
    l[i].duration(bufferlen);
    l[i].maxVoices(30);
    l[i].clear();
    l[i].gain(0.3);
    l[i].feedback(0.5);
    l[i].recRamp(20::ms);
    l[i].record(0);
    
    adc => l[i] => dac;
}

l[recbuf].record(1);

//create grains, rotate record and play bufs as needed
//shouldn't click as long as the grainlen < bufferlen
while(true) {
    
    now + bufferlen => time later;
    
    //toss some grains
    while (now<later) {
        
        Std.rand2f(0.8, 1.5) => float newrate;
        Std.rand2f(800, 900) * 1::ms => dur newdur;
        
        spork ~ getgrain(playbuf, newdur, 20::ms, 20::ms, newrate);
        
        freqmod.last() * 400. + 800. => s.freq;
        
        10::ms => now;
        
    }
    
    //rotate the record and playbufs
    l[recbuf++].record(0);
    if(recbuf == 3) 0 => recbuf;
    l[recbuf].record(1);
    
    playbuf++;
    if(playbuf == 3) 0 => playbuf;
    
}


fun void getgrain(int which, dur grainlen, dur rampup, dur rampdown, float rate)
{
    l[which].getVoice() => int newvoice;
    //<<<newvoice>>>;
    
    if(newvoice > -1) {
        l[which].rate(newvoice, rate);
        l[which].playPos(newvoice, Std.rand2f(0., 1.) * bufferlen);
        l[which].rampUp(newvoice, rampup);
        (grainlen - (rampup + rampdown)) => now;
        l[which].rampDown(newvoice, rampdown);
        rampdown => now;
    }
    
}
