
OscSend xmit;
xmit.setHost("localhost", 8888);


"fearless.wav" => string FILENAME;
if( me.args() > 0 ) me.arg(0) => FILENAME;



// overall volume
1 => float MAIN_VOLUME;
// grain duration base
900::ms => dur GRAIN_LENGTH;
// factor relating grain duration to ramp up/down time
.5 => float GRAIN_RAMP_FACTOR;
// playback rate
1 => float GRAIN_PLAY_RATE;
// grain position (0 start; 1 end)
0.3000 => float GRAIN_POSITION;
// grain position randomization
.001 => float GRAIN_POSITION_RANDOM;
// grain jitter (0 == periodic fire rate)
1 => float GRAIN_FIRE_RANDOM;

// max lisa voices
30 => int LISA_MAX_VOICES;
// load file into a LiSa (use one LiSa per sound)
load( FILENAME ) @=> LiSa @ lisa;

// patch it
PoleZero blocker => NRev reverb => dac;
// connect
lisa.chan(0) => Envelope lisa_gain_env => blocker;


// reverb mix
.03 => reverb.mix;
// pole location to block DC and ultra low frequencies
.99 => blocker.blockZero;


// HID objects
Hid hi;
HidMsg msg;

// which joystick
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// open joystick 0, exit on fail
if( !hi.openKeyboard( device ) ) me.exit();
// log
<<< "keyboard '" + hi.name() + "' ready", "" >>>;

// keys
45 => int KEY_DASH;
46 => int KEY_EQUAL;
54 => int KEY_COMMA;
55 => int KEY_PERIOD;
79 => int KEY_RIGHT;
80 => int KEY_LEFT;
81 => int KEY_DOWN;
82 => int KEY_UP;

// spork it
spork ~ print();
spork ~ kb();
spork ~ oscLoop();

// main loop
while( true )
{
    // fire a grain
    fireGrain();
    // amount here naturally controls amount of overlap between grains
    GRAIN_LENGTH / 8 + Math.random2f(0,GRAIN_FIRE_RANDOM)::ms => now;
}

fun void oscLoop(){
    
    150::ms => lisa_gain_env.duration;
    
    
    // osc has two ints - first specifies which movie, 
    // second specifies to start or stop
    // Ice loop
    repeat(20){ // TODO: set to 20
        lisa_gain_env.keyOn();
        lisa.gain(.5);
        1.8::second => now;
        //To send a message with no contents:
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(1);
        lisa_gain_env.keyOff();
        
        1.6::second => now;
        
        GRAIN_POSITION - 0.001 => GRAIN_POSITION;
        
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(0);
    }
    
    
    .92 => GRAIN_POSITION;
    400::ms => GRAIN_LENGTH;
        
    2::second => dur delta;
        
        
    //load explosion video
    xmit.startMsg("test, i, i");
    xmit.addInt(91); 
    xmit.addInt(00); //dummy
    
    repeat(7){ // TODO: set to 7
        
        lisa_gain_env.keyOn();
        lisa.gain(.5);
        delta => now;
        //To send a message with no contents:
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(1);
        lisa_gain_env.keyOff();
        
        delta * .75 => now;
        
        GRAIN_POSITION - 0.001 => GRAIN_POSITION;
        GRAIN_LENGTH * .92  => GRAIN_LENGTH;
        
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(0);
        
        delta * .90 => delta;
        
        <<< delta >>>;
            
    }
    

    
    
    repeat(50){ // TODO: set to 50
        
        lisa_gain_env.keyOn();
        lisa.gain(.5);
        delta => now;
        //To send a message with no contents:
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(1);
        lisa_gain_env.keyOff();
        
        delta * .75 => now;
        
        GRAIN_POSITION - 0.001 => GRAIN_POSITION;
        GRAIN_LENGTH * .92  => GRAIN_LENGTH;
        
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(0);
        
        delta * .90 => delta;
        
        <<< delta >>>;
        
    }
    
     // load water video
    xmit.startMsg("test, i, i");
    xmit.addInt(92);
    xmit.addInt(00); //dummy
    
    .5::second => now;
    
    
    // back to ice!!
    repeat(500){ // TODO: set to 1000
        lisa_gain_env.keyOn();
        lisa.gain(.5);
        delta => now;
        //To send a message with no contents:
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(1);
        lisa_gain_env.keyOff();
        
        150::ms => now;
        if(delta > .6::second){
            2::second => now;
        }
        delta * 1.05 => delta;
        
        GRAIN_POSITION - 0.001 => GRAIN_POSITION;
        
        xmit.startMsg("test, i, i");
        xmit.addInt(0);
        xmit.addInt(0);
    }
    
    
    
    // load ice video
    //xmit.startMsg("test, i, i");
    //xmit.addInt(90);
    //xmit.addInt(00); //dummy

    
    
    10::second => now;

    
    
    
}

// fire!
fun void fireGrain()
{
    // grain length
    GRAIN_LENGTH => dur grainLen;
    // ramp time
    GRAIN_LENGTH * GRAIN_RAMP_FACTOR => dur rampTime;
    // play pos
    GRAIN_POSITION + Math.random2f(0,GRAIN_POSITION_RANDOM) => float pos;
    // a grain
    if( lisa != null && pos >= 0 )
        spork ~ grain( lisa, pos * lisa.duration(), grainLen, rampTime, rampTime, 
        GRAIN_PLAY_RATE );
}

// grain sporkee
fun void grain( LiSa @ lisa, dur pos, dur grainLen, dur rampUp, dur rampDown, float rate )
{
    // get a voice to use
    lisa.getVoice() => int voice;
    
    // if available
    if( voice > -1 )
    {
        // set rate
        lisa.rate( voice, rate );
        // set playhead
        lisa.playPos( voice, pos );
        // ramp up
        lisa.rampUp( voice, rampUp );
        // wait
        (grainLen - rampUp) => now;
        // ramp down
        lisa.rampDown( voice, rampDown );
        // wait
        rampDown => now;
    }
}

// print
fun void print()
{
    // time loop
    while( true )
    {
        // values
        <<< "pos:", GRAIN_POSITION, "random:", GRAIN_POSITION_RANDOM,
        "rate:", GRAIN_PLAY_RATE, "size:", GRAIN_LENGTH/second >>>;
        // advance time
        100::ms => now;
    }
}

// keyboard
fun void kb()
{
    // infinite event loop
    while( true )
    {
        // wait on HidIn as event
        hi => now;
        
        // messages received
        while( hi.recv( msg ) )
        {
            // button donw
            if( msg.isButtonDown() )
            {
                if( msg.which == KEY_LEFT )
                {
                    .008 -=> GRAIN_PLAY_RATE;
                    if( GRAIN_PLAY_RATE < 0 ) 0 => GRAIN_PLAY_RATE;
                }
                else if( msg.which == KEY_RIGHT )
                {
                    .008 +=> GRAIN_PLAY_RATE;
                    if( GRAIN_PLAY_RATE > 2 ) 2 => GRAIN_PLAY_RATE;
                }
                else if( msg.which == KEY_DOWN )
                {
                    .005 -=> GRAIN_POSITION;
                    if( GRAIN_POSITION < 0 ) 0 => GRAIN_POSITION;
                }
                else if( msg.which == KEY_UP )
                {
                    .005 +=> GRAIN_POSITION;
                    if( GRAIN_POSITION > 1 ) 1 => GRAIN_POSITION;
                }
                else if( msg.which == KEY_COMMA )
                {
                    .95 *=> GRAIN_LENGTH;
                    if( GRAIN_LENGTH < 1::ms ) 1::ms => GRAIN_LENGTH;
                }
                else if( msg.which == KEY_PERIOD )
                {
                    1.05 *=> GRAIN_LENGTH;
                    
                    .9000::second => GRAIN_LENGTH;
                    if( GRAIN_LENGTH > 1::second ) 1::second => GRAIN_LENGTH;
                }
                else if( msg.which == KEY_DASH )
                {
                    .9 *=> GRAIN_POSITION_RANDOM;
                    if( GRAIN_POSITION_RANDOM < .000001 ) .000001 => GRAIN_POSITION_RANDOM;
                }
                else if( msg.which == KEY_EQUAL )
                {
                    1.1 *=> GRAIN_POSITION_RANDOM;
                    if( GRAIN_POSITION_RANDOM > 1 ) 1 => GRAIN_POSITION_RANDOM;
                }
            }
        }
    }
}




// load file into a LiSa
fun LiSa load( string filename )
{
    // sound buffer
    SndBuf buffy;
    // load it
    me.dir() + filename => buffy.read;
    
    // new LiSa
    LiSa lisa;
    // set duration
    buffy.samples()::samp => lisa.duration;
    
    // transfer values from SndBuf to LiSa
    for( 0 => int i; i < buffy.samples(); i++ )
    {
        // args are sample value and sample index
        // (dur must be integral in samples)
        lisa.valueAt( buffy.valueAt(i), i::samp );        
    }
    
    // set LiSa parameters
    lisa.play( false );
    lisa.loop( false );
    lisa.maxVoices( LISA_MAX_VOICES );
    
    return lisa;
}